{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TAttLine.Interface where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Core.TAttLine.RawType
import STD.Deletable.Interface

class (IDeletable a) => ITAttLine a where
        getLineColor :: () => a -> IO CShort
        
        getLineStyle :: () => a -> IO CShort
        
        getLineWidth :: () => a -> IO CShort
        
        resetAttLine :: (Castable c0 CString) => a -> c0 -> IO ()
        
        setLineAttributes :: () => a -> IO ()
        
        setLineColor :: () => a -> CShort -> IO ()
        
        setLineStyle :: () => a -> CShort -> IO ()
        
        setLineWidth :: () => a -> CShort -> IO ()

upcastTAttLine :: forall a . (FPtr a, ITAttLine a) => a -> TAttLine
upcastTAttLine h
  = let fh = get_fptr h
        fh2 :: Ptr RawTAttLine = castPtr fh
      in cast_fptr_to_obj fh2

downcastTAttLine ::
                 forall a . (FPtr a, ITAttLine a) => TAttLine -> a
downcastTAttLine h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
