{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module HROOT.Core.TColor.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import HROOT.Core.TColor.RawType
import HROOT.Core.TColor.RawType
import HROOT.Core.TObject.RawType
import HROOT.Core.TClass.RawType
import HROOT.Core.TArrayI.RawType

foreign import ccall interruptible
               "HROOTCoreTColor.h TColor_SetName" c_tcolor_setname ::
               Ptr RawTColor -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTColor.h TColor_SetNameTitle" c_tcolor_setnametitle ::
               Ptr RawTColor -> CString -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTColor.h TColor_SetTitle" c_tcolor_settitle ::
               Ptr RawTColor -> CString -> IO ()

foreign import ccall interruptible "HROOTCoreTColor.h TColor_Clear"
               c_tcolor_clear :: Ptr RawTColor -> CString -> IO ()

foreign import ccall interruptible "HROOTCoreTColor.h TColor_Draw"
               c_tcolor_draw :: Ptr RawTColor -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTColor.h TColor_FindObject" c_tcolor_findobject ::
               Ptr RawTColor -> CString -> IO (Ptr RawTObject)

foreign import ccall interruptible
               "HROOTCoreTColor.h TColor_GetName" c_tcolor_getname ::
               Ptr RawTColor -> IO CString

foreign import ccall interruptible "HROOTCoreTColor.h TColor_IsA"
               c_tcolor_isa :: Ptr RawTColor -> IO (Ptr RawTClass)

foreign import ccall interruptible "HROOTCoreTColor.h TColor_Paint"
               c_tcolor_paint :: Ptr RawTColor -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTColor.h TColor_printObj" c_tcolor_printobj ::
               Ptr RawTColor -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTColor.h TColor_SaveAs" c_tcolor_saveas ::
               Ptr RawTColor -> CString -> CString -> IO ()

foreign import ccall interruptible "HROOTCoreTColor.h TColor_Write"
               c_tcolor_write ::
               Ptr RawTColor -> CString -> CInt -> CInt -> IO CInt

foreign import ccall interruptible
               "HROOTCoreTColor.h TColor_Write_" c_tcolor_write_ ::
               Ptr RawTColor -> IO CInt

foreign import ccall interruptible
               "HROOTCoreTColor.h TColor_delete" c_tcolor_delete ::
               Ptr RawTColor -> IO ()

foreign import ccall interruptible
               "HROOTCoreTColor.h TColor_newTColor_" c_tcolor_newtcolor_ ::
               IO (Ptr RawTColor)

foreign import ccall interruptible
               "HROOTCoreTColor.h TColor_newTColor" c_tcolor_newtcolor ::
               CFloat -> CFloat -> CFloat -> CFloat -> IO (Ptr RawTColor)

foreign import ccall interruptible
               "HROOTCoreTColor.h TColor_tColor_GetPalette"
               c_tcolor_tcolor_getpalette :: IO (Ptr RawTArrayI)
