{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module HROOT.Core.TColor.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import HROOT.Core.TColor.RawType
import HROOT.Core.TColor.FFI
import HROOT.Core.TColor.Interface
import HROOT.Core.TColor.Cast
import HROOT.Core.TColor.RawType
import HROOT.Core.TColor.Cast
import HROOT.Core.TColor.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TArrayI.RawType
import HROOT.Core.TArrayI.Cast
import HROOT.Core.TArrayI.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => ITColor (TColor) where

instance () => ITNamed (TColor) where
        setName = xform1 c_tcolor_setname
        setNameTitle = xform2 c_tcolor_setnametitle
        setTitle = xform1 c_tcolor_settitle

instance () => ITObject (TColor) where
        clear = xform1 c_tcolor_clear
        draw = xform1 c_tcolor_draw
        findObject = xform1 c_tcolor_findobject
        getName = xform0 c_tcolor_getname
        isA = xform0 c_tcolor_isa
        paint = xform1 c_tcolor_paint
        printObj = xform1 c_tcolor_printobj
        saveAs = xform2 c_tcolor_saveas
        write = xform3 c_tcolor_write
        write_ = xform0 c_tcolor_write_

instance () => IDeletable (TColor) where
        delete = xform0 c_tcolor_delete

newTColor_ :: () => IO TColor
newTColor_ = xformnull c_tcolor_newtcolor_

newTColor ::
            () => CFloat -> CFloat -> CFloat -> CFloat -> IO TColor
newTColor = xform3 c_tcolor_newtcolor

tColor_GetPalette :: () => IO TArrayI
tColor_GetPalette = xformnull c_tcolor_tcolor_getpalette
