{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TDirectory.Interface where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Core.TDirectory.RawType
import HROOT.Core.TObject.RawType
import HROOT.Core.TNamed.Interface
import HROOT.Core.TObject.Interface
import HROOT.Core.TKey.Interface

class (ITNamed a) => ITDirectory a where
        append :: (ITObject c0, FPtr c0) => a -> c0 -> CBool -> IO ()
        
        addD :: (ITObject c0, FPtr c0) => a -> c0 -> CBool -> IO ()
        
        appendKey :: (ITKey c0, FPtr c0) => a -> c0 -> IO CInt
        
        close :: (Castable c0 CString) => a -> c0 -> IO ()
        
        get :: (Castable c0 CString) => a -> c0 -> IO TObject
        
        cd_TDirectory :: (Castable c0 CString) => a -> c0 -> IO CBool

upcastTDirectory ::
                 forall a . (FPtr a, ITDirectory a) => a -> TDirectory
upcastTDirectory h
  = let fh = get_fptr h
        fh2 :: Ptr RawTDirectory = castPtr fh
      in cast_fptr_to_obj fh2

downcastTDirectory ::
                   forall a . (FPtr a, ITDirectory a) => TDirectory -> a
downcastTDirectory h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
