{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module HROOT.Core.TObjArray.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import HROOT.Core.TObjArray.RawType
import HROOT.Core.TObjArray.RawType
import HROOT.Core.TObject.RawType
import HROOT.Core.TClass.RawType

foreign import ccall interruptible
               "HROOTCoreTObjArray.h TObjArray_Clear" c_tobjarray_clear ::
               Ptr RawTObjArray -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTObjArray.h TObjArray_Draw" c_tobjarray_draw ::
               Ptr RawTObjArray -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTObjArray.h TObjArray_FindObject" c_tobjarray_findobject
               :: Ptr RawTObjArray -> CString -> IO (Ptr RawTObject)

foreign import ccall interruptible
               "HROOTCoreTObjArray.h TObjArray_GetName" c_tobjarray_getname ::
               Ptr RawTObjArray -> IO CString

foreign import ccall interruptible
               "HROOTCoreTObjArray.h TObjArray_IsA" c_tobjarray_isa ::
               Ptr RawTObjArray -> IO (Ptr RawTClass)

foreign import ccall interruptible
               "HROOTCoreTObjArray.h TObjArray_Paint" c_tobjarray_paint ::
               Ptr RawTObjArray -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTObjArray.h TObjArray_printObj" c_tobjarray_printobj ::
               Ptr RawTObjArray -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTObjArray.h TObjArray_SaveAs" c_tobjarray_saveas ::
               Ptr RawTObjArray -> CString -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTObjArray.h TObjArray_Write" c_tobjarray_write ::
               Ptr RawTObjArray -> CString -> CInt -> CInt -> IO CInt

foreign import ccall interruptible
               "HROOTCoreTObjArray.h TObjArray_Write_" c_tobjarray_write_ ::
               Ptr RawTObjArray -> IO CInt

foreign import ccall interruptible
               "HROOTCoreTObjArray.h TObjArray_delete" c_tobjarray_delete ::
               Ptr RawTObjArray -> IO ()
