{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module HROOT.Core.TObject.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.FFI
import HROOT.Core.TObject.Interface
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => ITObject (TObject) where
        clear = xform1 c_tobject_clear
        draw = xform1 c_tobject_draw
        findObject = xform1 c_tobject_findobject
        getName = xform0 c_tobject_getname
        isA = xform0 c_tobject_isa
        paint = xform1 c_tobject_paint
        printObj = xform1 c_tobject_printobj
        saveAs = xform2 c_tobject_saveas
        write = xform3 c_tobject_write
        write_ = xform0 c_tobject_write_

instance () => IDeletable (TObject) where
        delete = xform0 c_tobject_delete

newTObject :: () => IO TObject
newTObject = xformnull c_tobject_newtobject

tObject_GetObjectStat :: () => IO CBool
tObject_GetObjectStat = xformnull c_tobject_tobject_getobjectstat
