{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module HROOT.Core.TVirtualPad.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import HROOT.Core.TVirtualPad.RawType
import HROOT.Core.TVirtualPad.FFI
import HROOT.Core.TVirtualPad.Interface
import HROOT.Core.TVirtualPad.Cast
import HROOT.Core.TVirtualPad.RawType
import HROOT.Core.TVirtualPad.Cast
import HROOT.Core.TVirtualPad.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TAttPad.RawType
import HROOT.Core.TAttPad.Cast
import HROOT.Core.TAttPad.Interface
import HROOT.Core.TQObject.RawType
import HROOT.Core.TQObject.Cast
import HROOT.Core.TQObject.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => ITVirtualPad (TVirtualPad) where
        cd = xform1 c_tvirtualpad_cd
        divide_tvirtualpad = xform5 c_tvirtualpad_divide_tvirtualpad
        modified = xform1 c_tvirtualpad_modified
        range = xform4 c_tvirtualpad_range
        setLogx = xform1 c_tvirtualpad_setlogx
        setLogy = xform1 c_tvirtualpad_setlogy
        setLogz = xform1 c_tvirtualpad_setlogz
        update = xform0 c_tvirtualpad_update

instance () => ITObject (TVirtualPad) where
        clear = xform1 c_tvirtualpad_clear
        draw = xform1 c_tvirtualpad_draw
        findObject = xform1 c_tvirtualpad_findobject
        getName = xform0 c_tvirtualpad_getname
        isA = xform0 c_tvirtualpad_isa
        paint = xform1 c_tvirtualpad_paint
        printObj = xform1 c_tvirtualpad_printobj
        saveAs = xform2 c_tvirtualpad_saveas
        write = xform3 c_tvirtualpad_write
        write_ = xform0 c_tvirtualpad_write_

instance () => ITAttLine (TVirtualPad) where
        getLineColor = xform0 c_tvirtualpad_getlinecolor
        getLineStyle = xform0 c_tvirtualpad_getlinestyle
        getLineWidth = xform0 c_tvirtualpad_getlinewidth
        resetAttLine = xform1 c_tvirtualpad_resetattline
        setLineAttributes = xform0 c_tvirtualpad_setlineattributes
        setLineColor = xform1 c_tvirtualpad_setlinecolor
        setLineStyle = xform1 c_tvirtualpad_setlinestyle
        setLineWidth = xform1 c_tvirtualpad_setlinewidth

instance () => ITAttFill (TVirtualPad) where
        setFillColor = xform1 c_tvirtualpad_setfillcolor
        setFillStyle = xform1 c_tvirtualpad_setfillstyle

instance () => ITAttPad (TVirtualPad) where
        resetAttPad = xform1 c_tvirtualpad_resetattpad
        setBottomMargin = xform1 c_tvirtualpad_setbottommargin
        setLeftMargin = xform1 c_tvirtualpad_setleftmargin
        setRightMargin = xform1 c_tvirtualpad_setrightmargin
        setTopMargin = xform1 c_tvirtualpad_settopmargin
        setMargin = xform4 c_tvirtualpad_setmargin
        setAfile = xform1 c_tvirtualpad_setafile
        setXfile = xform1 c_tvirtualpad_setxfile
        setYfile = xform1 c_tvirtualpad_setyfile
        setAstat = xform1 c_tvirtualpad_setastat
        setXstat = xform1 c_tvirtualpad_setxstat
        setYstat = xform1 c_tvirtualpad_setystat

instance () => ITQObject (TVirtualPad) where

instance () => IDeletable (TVirtualPad) where
        delete = xform0 c_tvirtualpad_delete
